
const web3 = require('@solana/web3.js');
const fs = require("fs-extra");
const BigNumber = require("bignumber.js");
const { Wallet } = require('@coral-xyz/anchor');
const Decimal = require('decimal.js');
const BN = require('bn.js');
const cron = require('node-cron');
const bs58 = require('bs58')
const raydium_sdk = require("@raydium-io/raydium-sdk");
const deepcopy = require('deepcopy');
const clear = require('clear');
const Config = require("./config")
const axios = require('axios');

let jsonInfo2PoolKeys = raydium_sdk.jsonInfo2PoolKeys;


let log = console.log;
console.log = function () {
    let args = Array.from(arguments);
    let log_prefix = new Date().toISOString();
    args.unshift(log_prefix + "");
    log.apply(console, args);
}
BigInt.prototype.toJSON = function () {
    return this.toString()
}


//定时任务每秒执行一次
let crontask;
let obj_dalaoAddress_2_arrdalao = Config.obj_dalaoAddress_2_arrdalao;
let mywalletaddress = Config.mywalletaddress;
let walletPrivateKey = Config.mywalletPrivateKey;
let Liquidity = raydium_sdk.Liquidity;
let LiquidityPoolKeys = raydium_sdk.LiquidityPoolKeys;
let Percent = raydium_sdk.Percent;
let Token = raydium_sdk.Token;
let TokenAmount = raydium_sdk.TokenAmount;
let CurrencyAmount = raydium_sdk.CurrencyAmount;
let ApiPoolInfoV4 = raydium_sdk.ApiPoolInfoV4;
let LIQUIDITY_STATE_LAYOUT_V4 = raydium_sdk.LIQUIDITY_STATE_LAYOUT_V4;
let MARKET_STATE_LAYOUT_V3 = raydium_sdk.MARKET_STATE_LAYOUT_V3;
let Market = raydium_sdk.Market;
let SPL_MINT_LAYOUT = raydium_sdk.SPL_MINT_LAYOUT;
let listen_axios_config = Config.listen_axios_config;

let Keypair = web3.Keypair;
let PublicKey = web3.PublicKey;


let wallet = new Wallet(Keypair.fromSecretKey(Uint8Array.from(bs58.decode(walletPrivateKey))))

let dalaobuytokenscounts_obj = {};
let obj_sellFailedInfo = {};
let obj_dalaoCheckStatus = {}; //dalao的状态 dalao -->[] 如何数组为空数组 说明没有对其进行tx分析 如果[true] 说明在进行分析 有一个true 就是在分析一个tx
// 遍历全部dalao的第一个address 即obj_dalaoAddress_2_arrdalao的key
for (let dalaoAddress of Object.keys(obj_dalaoAddress_2_arrdalao)) {

    dalaobuytokenscounts_obj[dalaoAddress] = {};
    obj_dalaoCheckStatus[dalaoAddress] = [];
}

const buySolAmount0_1 = BigInt(0.1 * 10 ** 9);
const buySolAmount0_2 = BigInt(0.2 * 10 ** 9);
const buySolAmount0_00001 = BigInt(0.00001 * 10 ** 9);


let arr_total_str_dalaoAddress_forlisten = Config.arr_total_str_dalaoAddress_forlisten;
// let arr_total_web3pub_dalaoAddress_forlisten = Config.arr_total_web3pub_dalaoAddress_forlisten;
let len_arr_total_dalaoAddress = Config.len_arr_total_dalaoAddress;
let obj_dalao_existtxhash_2_set = Config.obj_dalao_existtxhash_2_set
let obj_dalao_isbusy = Config.obj_dalao_isbusy;



function parsedtransaction(obj_transaction) {

    let arr_staticAccountKeys = obj_transaction.transaction.message.staticAccountKeys;
    arr_staticAccountKeys.forEach((val, index, arr) => arr[index] = val.toBase58());
    let arr_transaction_transaction_message_instructions = obj_transaction.transaction.message.compiledInstructions;
    if (arr_transaction_transaction_message_instructions == undefined) {
        return undefined;
    }
    let obj_swap_instructions = {}
    obj_transaction["obj_swap_instructions"] = obj_swap_instructions;

    for (let idx_instructions = 0; idx_instructions < arr_transaction_transaction_message_instructions.length; idx_instructions++) {
        let obj_instruction = arr_transaction_transaction_message_instructions[idx_instructions];
        let arr_accountKeyIndexes = obj_instruction.accountKeyIndexes;
        // console.log("arr_accountKeyIndexes=", arr_accountKeyIndexes.length)
        if (arr_accountKeyIndexes.length != 18) {
            continue;
        }
        arr_accountKeyIndexes.forEach((val, index, arr) => {
            arr[index] = arr_staticAccountKeys[val];
        });
        // console.log("arr_accountKeyIndexes=", arr_accountKeyIndexes)

        if (arr_accountKeyIndexes[0] != "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA" || arr_accountKeyIndexes[2] != "5Q544fKrFoe6tsEbD7S8EmxGTJYAKtTVhAW5Q5pge4j1") {
            // 不是raydium 的toekntransfer 跳过
            continue;
        }

        // new_arr_transaction_transaction_message_instructions.push(obj_instruction);
        let ammid = arr_accountKeyIndexes[1];
        obj_swap_instructions[ammid] = obj_instruction;

    }

    return obj_transaction;

}





async function buyToken({
    dalao_address,
    sign,
    str_maintoken_address,
    str_swaptoken_address,
    str_ammid,
    number_maintoken_decimals,
    number_swaptoken_decimals,
    bigint_actual_swapinamount,
    bigint_expect_swapminoutamount,
    arr_walletTokenAccount,
    wallet
} = {}) {
    console.log(`enter buyToken dalao_address=${dalao_address} sign=${sign} buysolamount=${bigint_actual_swapinamount}`);
    console.log("buyToken",
        dalao_address,
        sign,
        str_maintoken_address,
        str_swaptoken_address,
        str_ammid,
        number_maintoken_decimals,
        number_swaptoken_decimals,
        bigint_actual_swapinamount,
        bigint_expect_swapminoutamount,
        arr_walletTokenAccount,
        wallet)
    let ammpool = obj_total_ammpool[str_ammid];
    let poolkeys = jsonInfo2PoolKeys(ammpool);

    let inputToken = Token.WSOL;
    // let inputToken = new Token(raydium_sdk.TOKEN_PROGRAM_ID, new PublicKey(str_maintoken_address), number_maintoken_decimals, 'SOL', 'SOL');
    let outputToken = new Token(raydium_sdk.TOKEN_PROGRAM_ID, new PublicKey(str_swaptoken_address), number_swaptoken_decimals, 'TOKEN', 'TOKEN');

    let inputTokenAmount = new raydium_sdk.TokenAmount(inputToken, bigint_actual_swapinamount);


    let minAmountOutRaw = bigint_expect_swapminoutamount;

    let minAmountOut =
        outputToken instanceof Token
            ? new TokenAmount(outputToken, minAmountOutRaw)
            : new CurrencyAmount(outputToken, minAmountOutRaw)


    // -------- step 2: create instructions by SDK function --------
    const { innerTransactions } = await Liquidity.makeSwapInstructionSimple({
        connection: swap_connection,
        poolKeys: poolkeys,
        userKeys: {
            tokenAccounts: arr_walletTokenAccount,
            owner: wallet.publicKey,

        },
        amountIn: inputTokenAmount,
        amountOut: minAmountOut,
        fixedSide: 'in',
        makeTxVersion: raydium_sdk.TxVersion.V0,
        computeBudgetConfig: {
            microLamports: 5000000,
            // 17857143
            // 5000653 dalao的
            // 30000000


        },
    })


    const latestBlockHash = await swap_connection.getLatestBlockhash();
    const instructions = innerTransactions[0].instructions.filter(Boolean);
    const versionedTransaction = new web3.VersionedTransaction(
        new web3.TransactionMessage({
            payerKey: wallet.publicKey,
            recentBlockhash: latestBlockHash.blockhash,
            instructions: instructions,
        }).compileToV0Message()
    )

    // ,,,,,模拟买入
    await sleep(3000);

    let map_pendingSellToken_value = map_pendingSellToken.get(str_swaptoken_address);
    let obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];

    obj_dalaoInfo.bigint_myTokenAmount = obj_dalaoInfo.bigint_myTokenAmount + 1000n;

    console.log(`dalao_address=${dalao_address} sign=${sign} buysolamount=${bigint_actual_swapinamount} bigint_myTokenAmount=${obj_dalaoInfo.bigint_myTokenAmount} buyToken Success`);
    //计算购买价格
    let str_cur_buyprice = "0.001"
    if (accDiv(obj_dalaoInfo.str_maxbuyprice, str_cur_buyprice) < 1) {
        obj_dalaoInfo.str_maxbuyprice = str_cur_buyprice;
    }

    savePendingSellTokens();
    saveTotalAmmpool();
    updateWalletTokenAccount();
    saveWalletTokenAccount();
    save_obj_dalao_existtxhash_2_set();

    return;
    // versionedTransaction.sign([wallet.payer])
    // let res_sign = await swap_connection.sendTransaction(versionedTransaction);
    // console.log("res_sing=", res_sign);
    // console.log("latestBlockHash=", latestBlockHash);
    // let confirmationResult = await swap_connection.confirmTransaction(
    //   {
    //     blockhash: latestBlockHash.blockhash,
    //     lastValidBlockHeight: latestBlockHash.lastValidBlockHeight,
    //     signature: res_sign,
    //   }
    // );
    // console.log("confirmationResult=", confirmationResult);
    // if (confirmationResult.value.err) {
    //   console.log("confirmationResult error", confirmationResult.value.err)
    //   return;
    // }
    // //买入成功 更新数据
    // let obj_res_transaction = await swap_connection.getTransaction(res_sign, { commitment: "confirmed", maxSupportedTransactionVersion: 0 });
    // let [my_spl_dict, router_sol_dict, router_spl_dict] = get_dalaoArouter_changes_info(mywalletaddress, obj_res_transaction);
    // let dalao_spl_idx = my_spl_dict.mint.indexOf(str_swaptoken_address);
    // if (dalao_spl_idx == -1) {
    //   console.log(`warning dalao_spl_idx==-1`);
    //   return;
    // }
    // let map_pendingSellToken_value = map_pendingSellToken.get(str_swaptoken_address);
    // let obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
    // let bigint_my_spl_balance_changes = my_spl_dict.balance_changes[dalao_spl_idx];
    // let bigint_my_spl_postbalance = my_spl_dict.prepost_balances[dalao_spl_idx][1];
    // let bigint_my_sol_balance_changes = -router_sol_dict.balance_changes[0];
    // obj_dalaoInfo.bigint_myTokenAmount = bigint_my_spl_postbalance;
    // //计算购买价格
    // let str_cur_buyprice = accDiv(bigint_my_spl_balance_changes, -bigint_my_sol_balance_changes);
    // if (accDiv(obj_dalaoInfo.str_maxbuyprice, str_cur_buyprice) < 1) {
    //   obj_dalaoInfo.str_maxbuyprice = str_cur_buyprice;
    // }
    // savePendingSellTokens();
    // saveTotalAmmpool();
    // updateWalletTokenAccount();
    // saveWalletTokenAccount();
    // save_obj_dalao_existtxhash_2_set();

}

async function sellToken({
    dalao_address,
    sign,
    str_swapintoken,
    str_swapouttoken,
    str_ammid,
    number_decimals_swapintoken,
    number_decimals_swapouttoken,
    arr_walletTokenAccount,
    wallet,
    obj_someinfo

} = {}) {

    console.log(`enter sellToken dalao_address=${dalao_address} sign=${sign} `);
    console.log("sellToken",
        dalao_address,
        sign,
        str_swapintoken,
        str_swapouttoken,
        str_ammid,
        number_decimals_swapintoken,
        number_decimals_swapouttoken,

        arr_walletTokenAccount,
        wallet,
        obj_someinfo)


    let str_maintoken_address = str_swapouttoken;
    let str_swaptoken_address = str_swapintoken;
    let number_maintoken_decimals = number_decimals_swapouttoken;
    let number_swaptoken_decimals = number_decimals_swapintoken;


    // -------- pre-action: get pool info --------
    let ammpool = obj_total_ammpool[str_ammid];
    let poolkeys = jsonInfo2PoolKeys(ammpool);

    let inputToken = new Token(raydium_sdk.TOKEN_PROGRAM_ID, new PublicKey(str_swaptoken_address), number_swaptoken_decimals, 'TOKEN', 'TOKEN');
    // let outputToken = new Token(raydium_sdk.TOKEN_PROGRAM_ID, new PublicKey(str_maintoken_address), number_maintoken_decimals, 'SOL', 'SOL');
    let outputToken = Token.WSOL;


    let map_pendingSellToken_value = map_pendingSellToken.get(str_swaptoken_address);
    if (map_pendingSellToken_value == undefined) {
        console.log(`map_pendingSellToken_value is undefined`);
        return;
    }
    let obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
    if (obj_dalaoInfo == undefined) {
        console.log(`obj_dalaoInfo is undefined`);
        return;
    }
    if (obj_dalaoInfo.bigint_myTokenAmount == 0n) {
        console.log(`obj_dalaoInfo.bigint_myTokenAmount=0`);
        return;

    }

    obj_dalaoInfo.bigint_dalaoToken_NowAmount = obj_someinfo.bigint_dalaoToken_NowAmount;

    let number_sellpercent = Number((-obj_someinfo.bigint_dalaoToken_NowAmount + obj_someinfo.bigint_dalaoToken_PreAmount) * 100n / obj_someinfo.bigint_dalaoToken_PreAmount) / 100;

    if (number_sellpercent <= 0.1) {
        console.log(`dalao_address=${dalao_address} sign=${sign} NotSellToken number_sellpercent too low`)
        return;
    } else if (number_sellpercent >= 0.7) {
        console.log(`dalao_address=${dalao_address} sign=${sign} number_sellpercent convertto 1`)
        number_sellpercent = 1;

    }


    let bigint_AmountIn = BigInt(number_sellpercent * 100) * obj_dalaoInfo.bigint_myTokenAmount / 100n;
    let inputTokenAmount = new raydium_sdk.TokenAmount(inputToken, bigint_AmountIn);

    console.log(`sellToken dalao_address=${dalao_address} sign=${sign} token=${str_swaptoken_address} Amount=${inputTokenAmount.toFixed()}`);

    let minAmountOutRaw = 1n;
    let minAmountOut =
        outputToken instanceof Token
            ? new TokenAmount(outputToken, minAmountOutRaw)
            : new CurrencyAmount(outputToken, minAmountOutRaw)


    // -------- step 2: create instructions by SDK function --------

    const { innerTransactions } = await Liquidity.makeSwapInstructionSimple({
        connection: swap_connection,
        poolKeys: poolkeys,
        userKeys: {
            tokenAccounts: arr_walletTokenAccount,
            owner: wallet.publicKey,
        },
        amountIn: inputTokenAmount,
        amountOut: minAmountOut,
        fixedSide: 'in',
        makeTxVersion: raydium_sdk.TxVersion.V0,
        computeBudgetConfig: {
            microLamports: 5000000,
        },
    })





    const latestBlockHash = await swap_connection.getLatestBlockhash();
    const instructions = innerTransactions[0].instructions.filter(Boolean);
    const versionedTransaction = new web3.VersionedTransaction(
        new web3.TransactionMessage({
            payerKey: wallet.publicKey,
            recentBlockhash: latestBlockHash.blockhash,
            instructions: instructions,
        }).compileToV0Message()
    )
    await sleep(3000);
    obj_dalaoInfo.bigint_myTokenAmount = obj_dalaoInfo.bigint_myTokenAmount - bigint_AmountIn;

    console.log(`dalao_address=${dalao_address} sign=${sign} sellToken Success`);
    return;
    // versionedTransaction.sign([wallet.payer])
    // let res_sign = await swap_connection.sendTransaction(versionedTransaction);
    // console.log("res_sing=", res_sign);
    // console.log("latestBlockHash=", latestBlockHash);
    // let confirmationResult = await swap_connection.confirmTransaction(
    //   {
    //     blockhash: latestBlockHash.blockhash,
    //     lastValidBlockHeight: latestBlockHash.lastValidBlockHeight,
    //     signature: res_sign,
    //   }
    // );
    // console.log("confirmationResult=", confirmationResult);
    // if (confirmationResult.value.err) {
    //   console.log("confirmationResult error", confirmationResult.value.err)
    //   //卖出失败 拉黑
    //   sellFailStatistics({
    //     "tokenAddress": str_swaptoken_address,
    //     "pendingSellToken": map_pendingSellToken_value
    //   })
    //   return;
    // }

    // //卖出成功 更新数据
    // let obj_res_transaction = await swap_connection.getTransaction(res_sign, { commitment: "confirmed", maxSupportedTransactionVersion: 0 });
    // let [my_spl_dict, router_sol_dict, router_spl_dict] = get_dalaoArouter_changes_info(mywalletaddress, obj_res_transaction);
    // let dalao_spl_idx = my_spl_dict.mint.indexOf(str_swaptoken_address);
    // if (dalao_spl_idx == -1) {
    //   console.log(`warning dalao_spl_idx==-1`);
    //   //拉黑
    //   sellFailStatistics({
    //     "tokenAddress": str_swaptoken_address,
    //     "pendingSellToken": map_pendingSellToken_value
    //   })
    //   return;
    // }

    // let bigint_my_spl_balance_changes = my_spl_dict.balance_changes[dalao_spl_idx];
    // let bigint_my_spl_postbalance = my_spl_dict.prepost_balances[dalao_spl_idx][1];
    // let bigint_my_sol_balance_changes = -router_sol_dict.balance_changes[0];
    // obj_dalaoInfo.bigint_myTokenAmount = bigint_my_spl_postbalance;
    // //计算卖出价格 防止貔貅被坑
    // let str_cur_sellprice = accDiv(-bigint_my_spl_balance_changes, bigint_my_sol_balance_changes);
    // if (accDiv(obj_dalaoInfo.str_maxbuyprice, str_cur_sellprice) >= 8) {
    //   //价格差距过大 拉黑
    //   sellFailStatistics({
    //     "tokenAddress": str_swaptoken_address,
    //     "pendingSellToken": map_pendingSellToken_value
    //   })

    // }

    // savePendingSellTokens();
    // saveTotalAmmpool();
    // updateWalletTokenAccount();
    // saveWalletTokenAccount();
    // save_obj_dalao_existtxhash_2_set();



}


function getTimeMinDiff(startDateNow, endDateNow) {
    let timeDiff = endDateNow - startDateNow;  // 时间差的毫秒数
    let min = Math.floor(timeDiff / (60 * 1000)); // 计算出分钟
    return min;
};

function saveTotalAmmpool() {
    try {
        fs.writeJSONSync('total_ammpool.json', obj_total_ammpool, { spaces: 4 });
        console.log('save_total_ammpool success');
    } catch (error) {
        console.log('save_total_ammpool error=', error.message);
    }
}


function saveWalletTokenAccount() {
    try {

        fs.writeJSONSync('arr_walletTokenAccount.json', arr_walletTokenAccount, { spaces: 4 });
        console.log('saveWalletTokenAccount success');

    } catch (error) {
        console.log('saveWalletTokenAccount error error=', error.message);
    }
}


// function init_obj_dalao_existtxhash_2_set() {
//   if (!fs.existsSync('dalao_existtxhash_2_set.json')) {
//     console.log("init_obj_dalao_existtxhash_2_set success");
//     return;
//   }
//   obj_dalao_existtxhash_2_set = fs.readJSONSync('dalao_existtxhash_2_set.json', { encoding: 'utf8', flag: 'r' });
//   let arr_keys_obj_dalao_existtxhash_2_set = obj_dalao_existtxhash_2_set.keys();
//   for (let key of arr_keys_obj_dalao_existtxhash_2_set) {
//     obj_dalao_existtxhash_2_set[key] = new Set(obj_dalao_existtxhash_2_set[key]);
//   }

// }



//初始化文本中的代卖出代币信息
function initPendingSellTokens() {
    try {
        // let data;
        //同步的方式读取文件
        if (!fs.existsSync('pendingSellToken.json')) {

            console.log("初始化待卖出代币信息成功");
            return;
        }
        map_pendingSellToken = fs.readJSONSync('pendingSellToken.json', { encoding: 'utf8', flag: 'r' });
        // data = JSON.parse(data);
        //还原 
        map_pendingSellToken = new Map(Object.entries(map_pendingSellToken));
        if (map_pendingSellToken.size > 0) {
            //遍历
            // for (const [tokenAddress, map_pendingSellToken_value ] of map_pendingSellToken) {
            //检测当前是否还持有 此token
            for (let obj_walletTokenAccount of arr_walletTokenAccount) {
                let token_address = obj_walletTokenAccount.accountInfo.mint.toBase58();

                if (!map_pendingSellToken.has(token_address)) {
                    continue;
                }
                let token_amount = BigInt(obj_walletTokenAccount.accountInfo.amount.toString());
                if (token_amount == 0n) {
                    //删除此token信息 
                    map_pendingSellToken.delete(token_address);
                    continue;
                }
                let obj_total_dalaoInfo = map_pendingSellToken.get(token_address).obj_total_dalaoInfo;
                let arr_dalao = Object.keys(obj_total_dalaoInfo);
                for (let dalao_address of arr_dalao) {
                    let dalaoInfo = obj_total_dalaoInfo[dalao_address];
                    dalaoInfo["bigint_myMainTokenAmount"] = BigInt(dalaoInfo["bigint_myMainTokenAmount"]);
                    dalaoInfo["bigint_myTokenAmount"] = BigInt(dalaoInfo["bigint_myTokenAmount"]);
                    dalaoInfo["bigint_dalaoTokenAmount"] = BigInt(dalaoInfo["bigint_dalaoTokenAmount"]);
                    dalaoInfo["bigint_dalaoToken_PreAmount"] = BigInt(dalaoInfo["bigint_dalaoToken_PreAmount"]);
                    dalaoInfo["bigint_dalaoToken_NowAmount"] = BigInt(dalaoInfo["bigint_dalaoToken_NowAmount"]);
                    if (dalaoInfo["bigint_myTokenAmount"] == 0n) {
                        delete obj_total_dalaoInfo[dalao_address];
                    }
                }
            }

        }
        console.log("初始化待卖出代币信息成功");

    }
    catch (error) {
        console.log('初始化待卖出代币信息失败 error=', error.message);
        throw error;
    }

};

//保存待卖出代币信息到本地文本。
function savePendingSellTokens() {
    try {
        const plainObject = Map2PlainObject(map_pendingSellToken);
        fs.writeFileSync('pendingSellToken.json', JSON.stringify(plainObject));
        console.log('savePendingSellTokens success');

    } catch (error) {
        console.log('savePendingSellTokens error error=', error.message);
    }
};

function save_obj_dalao_existtxhash_2_set() {
    try {
        let new_obj_dalao_existtxhash_2_set = Map2PlainObject(obj_dalao_existtxhash_2_set);
        fs.writeJSONSync('dalao_existtxhash_2_set.json', new_obj_dalao_existtxhash_2_set, { spaces: 4 });
        console.log('save_obj_dalao_existtxhash_2_set success');
    } catch (error) {
        console.log('save_obj_dalao_existtxhash_2_set error=', error.message);
    }

}


//统计卖出失败（或者卖出金额有问题）次数, 当4小时内同一个Dalao触发风控统计超过3次,则启动风控,该Dalao不再跟单休息10小时。
async function sellFailStatistics({
    tokenAddress,
    pendingSellToken = undefined,

} = {}) {
    //保存貔貅发送者钱包
    //检查风控次数
    // 如果sleep_immediately 为true pendingSellToken应该hiundefined
    // dalaoAddress 可能为undefined 出现为undeined 一般意味着拉黑全部

    if (!pendingSellToken) {
        return;
    }
    let arr_dalaoAddress = pendingSellToken.arr_dalaoAddress;

    for (let dalaoAddress of arr_dalaoAddress) {
        let sellFailedInfo = obj_sellFailedInfo[dalaoAddress];
        if (sellFailedInfo != undefined) {
            sellFailedInfo.remainsellFailCount = sellFailedInfo.remainsellFailCount - 1;
            console.log(`PRINT dalaoAddress=${dalaoAddress} tokenAddress=${tokenAddress} remainsellFailCount ${sellFailedInfo.remainsellFailCount}`);
            if (sellFailedInfo.remainsellFailCount < 0) {
                //判断失败3次总耗时 如果大于4小时,就清零
                const etimeMinDiff = getTimeMinDiff(sellFailedInfo.sellFailStartTime, Date.now());
                if (etimeMinDiff >= 240) {
                    //移除
                    delete obj_sellFailedInfo[dalaoAddress];
                    console.log(`PRINT dalaoAddress=${dalaoAddress} Remove_RiskControl,has_more_than_4_hours_lasttime`);
                } else {
                    sellFailedInfo.stopTransactionTime = Date.now();
                    console.log(`PRINT dalaoAddress=${dalaoAddress} Excute_RiskControl,Sleeping_10_hours`);
                }
            } else {
                //判断距离上次失败总耗时 如果大于4小时,就重新统计
                const etimeMinDiff = getTimeMinDiff(sellFailedInfo.sellFailStartTime, Date.now());
                if (etimeMinDiff >= 240) {
                    //修改

                    sellFailedInfo.sellFailStartTime = Date.now();
                    console.log(`PRINT dalaoAddress=${dalaoAddress} has_more_than_4_hours_lasttime,RiskControlCount_init`);
                }
            }
        } else {
            obj_sellFailedInfo.set(dalaoAddress, { "remainsellFailCount": sellFailCountLimit - 1, "sellFailStartTime": Date.now(), "stopTransactionTime": 0 });
            console.log(`PRINT dalaoAddress=${dalaoAddress} tokenAddress=${tokenAddress} Trigger_RiskControl 1 time`);
        }
    }

};

let arr_walletTokenAccount = [];
let obj_total_ammpool = {}; // ammid ->poolkeys {}
// let obj_total_lp_info = {}; // lp_address ->info {decimals,xxx}
// let obj_total_token_info = {}; //token_address ->info  {decimals }




// let wallet = Keypair.fromSecretKey(Buffer.from(bs58.decode('41Svd4pDN1t3qhG9HH83LNsuP3ghPPDtUGKmsNoKTk6VoJXqqC9GhS7NGcwosYtm7NnDidhTWDkzKC8Gp9B7u4Av')));
// let swap_connection = new web3.Connection("https://mainnet.helius-rpc.com/?api-key=4c4f2b5f-7db5-489c-a74c-a334d8cedd76");

// arr_walletTokenAccount type is [
//   {
//     pubkey: PublicKey [PublicKey(GXGpJMgCCmJp11uPDzWBfNDu2tKpZLRjZ8vRkW6Bsf8M)] {
//       _bn: <BN: e6a09c5e639f40343b256cb45847f9c14dac8740f573a1cc6d5ad9d90224ce52>
//     },
//     programId: PublicKey [PublicKey(TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA)] {
//       _bn: <BN: 6ddf6e1d765a193d9cbe146ceeb79ac1cb485ed5f5b37913a8cf5857eff00a9>
//     },
//     accountInfo: {
//       mint: [PublicKey [PublicKey(EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v)]],
//       owner: [PublicKey [PublicKey(EuCYZeczx4L2y8HozZRgNsp17UtmeuN1gzBDn2ubW71k)]],
//       amount: <BN: 22>,
//       delegateOption: 0,
//       delegate: [PublicKey [PublicKey(11111111111111111111111111111111)]],
//       state: 1,
//       isNativeOption: 0,
//       isNative: <BN: 0>,
//       delegatedAmount: <BN: 0>,
//       closeAuthorityOption: 0,
//       closeAuthority: [PublicKey [PublicKey(11111111111111111111111111111111)]]
//     }
//   }
// ]


async function getWalletTokenAccount(wallet_pubkey) {

    const walletTokenAccount = await swap_connection.getTokenAccountsByOwner(wallet_pubkey, {
        programId: raydium_sdk.TOKEN_PROGRAM_ID,
    });

    return walletTokenAccount.value.map((i) => ({
        pubkey: i.pubkey,
        programId: i.account.owner,
        accountInfo: raydium_sdk.SPL_ACCOUNT_LAYOUT.decode(i.account.data),
    }));

}

async function updateWalletTokenAccount() {
    let temp_arr_walletTokenAccount;
    let retry_times = 3;
    while (retry_times > 0) {
        retry_times--;

        try {
            temp_arr_walletTokenAccount = await getWalletTokenAccount(wallet.publicKey);
            // temp_stringify = JSON.stringify(temp_arr_walletTokenAccount);
            // temp_arr_walletTokenAccount = JSON.parse(temp_stringify);
            if (temp_arr_walletTokenAccount.length == 0) {
                throw ("length error");
            }
        } catch (e) {
            console.log("updateWalletTokenAccount error", e);
            return;
        }
        arr_walletTokenAccount = temp_arr_walletTokenAccount;
        if (arr_walletTokenAccount.length != 0) {
            break;
        }
        await sleep(400);
    }


}
let WSOL_Token_Address = "So11111111111111111111111111111111111111112";
let Token_Transfer_programId = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
let Raydium_Authority_V4 = "5Q544fKrFoe6tsEbD7S8EmxGTJYAKtTVhAW5Q5pge4j1";

function set_token_balance(dalao_address, dict_temp_preTokenBalance, dict_temp_postTokenBalance, dalao_spl_dict, router_sol_dict, router_spl_dict) {
    if (dict_temp_preTokenBalance.programId != Token_Transfer_programId) {
        return;
    }
    if (![dalao_address, Raydium_Authority_V4].includes(dict_temp_preTokenBalance.owner)) {
        return;
    }
    // 前后tokenamount的数目没有变化 return
    if (dict_temp_preTokenBalance.uiTokenAmount.amount == dict_temp_postTokenBalance.uiTokenAmount.amount) {
        return;
    }


    if ([dalao_address].includes(dict_temp_preTokenBalance.owner)) {
        if ([WSOL_Token_Address].includes(dict_temp_preTokenBalance.mint)) {
            return;
        } else {
            dalao_spl_dict.mint.push(dict_temp_preTokenBalance.mint);
            dalao_spl_dict.balance_changes.push(-BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount) + BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount));
            dalao_spl_dict.prepost_balances.push([BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount), BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount)]);

        }
    } else if ([Raydium_Authority_V4].includes(dict_temp_preTokenBalance.owner)) {
        if ([WSOL_Token_Address].includes(dict_temp_preTokenBalance.mint)) {
            router_sol_dict.balance_changes.push(-BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount) + BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount));
            router_sol_dict.prepost_balances.push([BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount), BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount)]);
        } else {
            router_spl_dict.mint.push(dict_temp_preTokenBalance.mint);
            router_spl_dict.balance_changes.push(-BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount) + BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount));
            router_spl_dict.prepost_balances.push([BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount), BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount)]);
        }
    }

    return;
}

async function readyBuyToken({
    dalao_address,
    sign,
    str_swapintoken,
    str_swapouttoken,
    str_ammid,
    number_decimals_swapintoken,
    number_decimals_swapouttoken,
    bigint_actual_swapinamount,
    bigint_expect_swapminoutamount,
    arr_walletTokenAccount,
    wallet,
    obj_someinfo

} = {}) {
    console.log(`enter readyBuyToken dalao_address=${dalao_address} sign=${sign} swapin=${bigint_actual_swapinamount} swapminout=${bigint_expect_swapminoutamount}`);
    console.log("readyBuyToken", dalao_address,
        sign,
        str_swapintoken,
        str_swapouttoken,
        str_ammid,
        number_decimals_swapintoken,
        number_decimals_swapouttoken,
        bigint_actual_swapinamount,
        bigint_expect_swapminoutamount,
        arr_walletTokenAccount,
        wallet,
        obj_someinfo
    )
    let str_maintoken_address = str_swapintoken;
    let str_swaptoken_address = str_swapouttoken;
    let number_maintoken_decimals = number_decimals_swapintoken;
    let number_swaptoken_decimals = number_decimals_swapouttoken;


    if (dalaobuytokenscounts_obj[dalao_address][str_swaptoken_address]) {
        // dalaobuytokenscounts_obj 存在这个token信息，说明之前买过后来remove这个token了
        if (dalaobuytokenscounts_obj[dalao_address][str_swaptoken_address]['buyCounts'] >= 1) {
            console.log(`PRINT dalaoAddress=${dalao_address} tokenAddress=${str_swaptoken_address} txHash=${sign} NotBuyToken exceed_buy_counts_limits`);
            return;
        } else {
            dalaobuytokenscounts_obj[dalao_address][str_swaptoken_address]['buyCounts']++;
        }
    } else {
        dalaobuytokenscounts_obj[dalao_address][str_swaptoken_address] = { 'buyCounts': 1 }
    }

    // 三种情况,第一种完全没有这个token map_pendingSellToken 中没有 pendingSellToken
    // 第二种 有这个token 有pendingSellToken tokenInfoMap没有这个dalao
    // 第三种 有这个token  有 pendingSellToken tokenInfoMap有这个dalao
    // 对于dalao信息的设置 全部在buy成功之后再说
    let map_pendingSellToken_value = map_pendingSellToken.get(str_swaptoken_address);
    let obj_dalaoInfo;

    if (map_pendingSellToken_value == undefined) {
        //第一种 map_pendingSellToken 没有此token 设置

        map_pendingSellToken.set(str_swaptoken_address, {
            "str_maintoken": str_maintoken_address,
            "str_swaptoken": str_swaptoken_address,
            "ammid": str_ammid,
            "number_maintoken_decimals": number_maintoken_decimals,
            "number_swaptoken_decimals": number_swaptoken_decimals,
            "number_totallastBuydatenow": 0,
            "arr_dalaoAddress": [dalao_address],
            "arr_txHash": [],

            "obj_total_dalaoInfo": {}

        });
        map_pendingSellToken_value = map_pendingSellToken.get(str_swaptoken_address);
        map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address] = {
            "str_dalao_address": dalao_address,
            "str_maintoken": str_maintoken_address,
            "str_swaptoken": str_swaptoken_address,
            "ammid": str_ammid,
            "isSelling": false,
            "bigint_myMainTokenAmount": 0n,
            "bigint_myTokenAmount": 0n,
            "str_maxbuyprice": "",
            "bigint_dalaoTokenAmount": 0n,
            "bigint_dalaoToken_PreAmount": 0n,
            "bigint_dalaoToken_NowAmount": 0n
        };
        obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
    } else {
        //第二种与第三种

        //第三种是 obj_dalaoInfo!=undefined 在后面与 第一种第二种统一操作

        obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
        if (obj_dalaoInfo == undefined) {
            // 第二种 有这个token 有pendingSellToken tokenInfoMap没有这个dalao
            //准备购买
            map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address] = {
                "str_dalao_address": dalao_address,
                "str_maintoken": str_maintoken_address,
                "str_swaptoken": str_swaptoken_address,
                "ammid": str_ammid,
                "isSelling": false,
                "bigint_myMainTokenAmount": 0n,
                "bigint_myTokenAmount": 0n,
                "str_maxbuyprice": "",
                "bigint_dalaoTokenAmount": 0n,
                "bigint_dalaoToken_PreAmount": 0n,
                "bigint_dalaoToken_NowAmount": 0n
            }

            obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
        }


    }
    map_pendingSellToken_value.number_totallastBuydatenow = Date.now();
    map_pendingSellToken_value.arr_txHash.push(sign);
    if (!map_pendingSellToken_value.arr_dalaoAddress.includes(dalao_address)) {
        map_pendingSellToken_value.arr_dalaoAddress.push(dalao_address)
    }
    obj_dalaoInfo.bigint_dalaoToken_NowAmount = obj_someinfo.bigint_dalaoToken_NowAmount;
    obj_dalaoInfo.bigint_dalaoToken_PreAmount = obj_someinfo.bigint_dalaoToken_NowAmount;



    await buyToken({
        dalao_address,
        sign,
        str_maintoken_address,
        str_swaptoken_address,
        str_ammid,
        number_maintoken_decimals,
        number_swaptoken_decimals,
        bigint_actual_swapinamount,
        bigint_expect_swapminoutamount,
        arr_walletTokenAccount,
        wallet
    });

}


function get_dalaoArouter_changes_info(dalao_address, obj_transaction) {
    let temp_preTokenBalances_arr = [];
    let temp_postTokenBalances_arr = [];

    let slot = obj_transaction['slot'];
    temp_preTokenBalances_arr = obj_transaction["meta"]["preTokenBalances"];
    temp_postTokenBalances_arr = obj_transaction["meta"]["postTokenBalances"];
    let dalao_sol_dict = {
        "owner": dalao_address,
        "mint": [WSOL_Token_Address],
        "programId": Token_Transfer_programId,
        "balance_changes": [],
        "prepost_balances": [],

    };
    let dalao_spl_dict = {
        "owner": dalao_address,
        "mint": [],
        "programId": Token_Transfer_programId,
        "balance_changes": [],
        "prepost_balances": [],

    };
    let router_sol_dict = {
        "owner": Raydium_Authority_V4,
        "mint": [WSOL_Token_Address],
        "programId": Token_Transfer_programId,
        "balance_changes": [],
        "prepost_balances": [],

    };
    let router_spl_dict = {
        "owner": Raydium_Authority_V4,
        "mint": [],
        "programId": Token_Transfer_programId,
        "balance_changes": [],
        "prepost_balances": [],

    };
    // pre/postTokenBalances 理论上有三个 分别是router的wsol与spl的transfer dalao的spl transfer
    let temp_preTokenBalances_len = temp_preTokenBalances_arr.length;
    let temp_postTokenBalances_len = temp_postTokenBalances_arr.length;

    let temp_preTokenBalances_idx = 0
    let temp_postTokenBalances_idx = 0
    // # 获取TokenBalances与swap有关的信息
    // # for tokenbalance_idx in range(0,temp_postTokenBalances_len):
    // # 理论上 post >=pre 因为可能存在账户 在pre没有创建 在post创建  不会在pre中显示
    while (temp_preTokenBalances_idx < temp_preTokenBalances_len && temp_postTokenBalances_idx < temp_postTokenBalances_len) {
        let dict_temp_preTokenBalance = null;
        let dict_temp_postTokenBalance = null;

        if (temp_preTokenBalances_arr[temp_preTokenBalances_idx].accountIndex < temp_postTokenBalances_arr[temp_postTokenBalances_idx].accountIndex) {
            dict_temp_preTokenBalance = temp_preTokenBalances_arr[temp_preTokenBalances_idx];
            dict_temp_postTokenBalance = deepcopy(dict_temp_preTokenBalance);

            dict_temp_postTokenBalance.uiTokenAmount.amount = "0";
            temp_preTokenBalances_idx++;
        } else if (temp_preTokenBalances_arr[temp_preTokenBalances_idx].accountIndex > temp_postTokenBalances_arr[temp_postTokenBalances_idx].accountIndex) {
            dict_temp_postTokenBalance = temp_postTokenBalances_arr[temp_postTokenBalances_idx];

            dict_temp_preTokenBalance = deepcopy(dict_temp_postTokenBalance);

            dict_temp_preTokenBalance.uiTokenAmount.amount = "0";
            temp_postTokenBalances_idx++;
        } else {
            dict_temp_preTokenBalance = temp_preTokenBalances_arr[temp_preTokenBalances_idx];
            dict_temp_postTokenBalance = temp_postTokenBalances_arr[temp_postTokenBalances_idx];
            temp_preTokenBalances_idx++;
            temp_postTokenBalances_idx++;
        }

        set_token_balance(dalao_address, dict_temp_preTokenBalance, dict_temp_postTokenBalance, dalao_spl_dict, router_sol_dict, router_spl_dict);
    }

    while (temp_preTokenBalances_idx < temp_preTokenBalances_len) {
        let dict_temp_preTokenBalance = temp_preTokenBalances_arr[temp_preTokenBalances_idx];

        let dict_temp_postTokenBalance = deepcopy(dict_temp_preTokenBalance);
        dict_temp_postTokenBalance.uiTokenAmount.amount = "0";
        set_token_balance(dalao_address, dict_temp_preTokenBalance, dict_temp_postTokenBalance, dalao_spl_dict, router_sol_dict, router_spl_dict);
        temp_preTokenBalances_idx += 1;
    }

    while (temp_postTokenBalances_idx < temp_postTokenBalances_len) {
        let dict_temp_postTokenBalance = temp_postTokenBalances_arr[temp_postTokenBalances_idx];

        let dict_temp_preTokenBalance = deepcopy(dict_temp_postTokenBalance);
        dict_temp_preTokenBalance.uiTokenAmount.amount = "0";
        set_token_balance(dalao_address, dict_temp_preTokenBalance, dict_temp_postTokenBalance, dalao_spl_dict, router_sol_dict, router_spl_dict);
        temp_postTokenBalances_idx += 1;
    }

    return [dalao_spl_dict, router_sol_dict, router_spl_dict];


}
async function get_dalao_transaction_info(dalao_address, sign, obj_transaction) {

    // dalao transaction 获取到 dalao 与raydium pool 的token transfer 信息 并与 swap instruction 进行比较 
    // 1 buy raydium in wsol out token dalao in token
    // 2 sell
    // 3 sell 没有swap 或者swap 与token 无关 dalao out token 在pendingsellToken信息中
    // 判断sell 比较简单 只要 dalao 出现 dalao tokenamount 减少  就sell
    //判断buy 满足 dalao in token， raydium pool in wsol ，out token token 与 sol 在swap 的instruction 可以找到
    console.log(`enter get_dalao_transaction_info dalao_address=${dalao_address} sign=${sign}`)
    let dalao_spl_dict, router_sol_dict, router_spl_dict;
    let obj_dalao_transaction_info = {
        "str_swaptype": "noswap",
        "str_dalao_intoken": "",
        "str_dalao_outtoken": "",
        "str_ammid": "",
        "bigint_dalaoinamount": 0n,
        "bigint_dalaooutamount": 0n,
        "number_decimals_dalao_intoken": 0,
        "number_decimals_dalao_outtoken": 0,
        "bigint_dalaoToken_PreAmount": 0n,
        "bigint_dalaoToken_NowAmount": 0n,
    };

    [dalao_spl_dict, router_sol_dict, router_spl_dict] = get_dalaoArouter_changes_info(dalao_address, obj_transaction);
    console.log('dalao_spl_dict=', dalao_spl_dict)
    console.log('router_sol_dict=', router_sol_dict)
    console.log('router_spl_dict=', router_spl_dict)



    if (
        dalao_spl_dict["balance_changes"].length == 0 ||
        router_sol_dict["balance_changes"].length == 0 ||
        router_spl_dict["balance_changes"].length == 0
    ) {
        // 如果 dalao 与router 没有 TokenBalances的信息 也就是没有token transfer的信息  说明此tx不是所需的swap
        console.log(`sign=${sign}  no balance_changes`);
        return obj_dalao_transaction_info;
    }

    // 判断 是swap type 先判断dalao outtoken 情况
    // 只要 dalao 有outtoken 就算sell 不用考虑太复杂 这和你赚第一通金无关


    for (let dalao_mint_idx = 0; dalao_mint_idx < dalao_spl_dict.mint.length; dalao_mint_idx++) {
        //此轮循环值判断 balance_changes<0 即疑似卖出的情况
        let token_address = dalao_spl_dict.mint[dalao_mint_idx];
        let bigint_dalao_spl_balance_changes = dalao_spl_dict.balance_changes[dalao_mint_idx];
        let bigint_dalao_spl_prebalance = dalao_spl_dict.prepost_balances[dalao_mint_idx][0];
        let bigint_dalao_spl_postbalance = dalao_spl_dict.prepost_balances[dalao_mint_idx][1];

        if (bigint_dalao_spl_balance_changes >= 0n) {
            continue;
        }

        let map_pendingSellToken_value = map_pendingSellToken.get(token_address);
        if (map_pendingSellToken_value == undefined) {
            //map_pendingSellToken 没有此token 跳过
            continue;
        }
        let obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
        if (obj_dalaoInfo == undefined) {
            console.log(`obj_dalaoInfo is undefined`);
            return;
        }

        // "str_maintoken": "So11111111111111111111111111111111111111112",
        // "str_swaptoken": "GacrmxfxRBGACEXf7D3gLqtfuUhmVw92ybvGN8cMTcvJ",
        // "ammid": "JCtzsX1FQk8MyqGfH6weanxeo6M3swuCZCQ2C6aVPkT8",
        // "number_maintoken_decimals": 9,
        // "number_swaptoken_decimals": 6,

        obj_dalao_transaction_info.str_swaptype = "sell";
        obj_dalao_transaction_info.str_dalao_intoken = map_pendingSellToken_value.str_maintoken;
        obj_dalao_transaction_info.str_dalao_outtoken = map_pendingSellToken_value.str_swaptoken;
        obj_dalao_transaction_info.str_ammid = map_pendingSellToken_value.ammid;
        obj_dalao_transaction_info.bigint_dalaoinamount = 0n;
        obj_dalao_transaction_info.bigint_dalaooutamount = -bigint_dalao_spl_balance_changes;
        obj_dalao_transaction_info.number_decimals_dalao_intoken = map_pendingSellToken_value.number_maintoken_decimals;
        obj_dalao_transaction_info.number_decimals_dalao_outtoken = map_pendingSellToken_value.number_swaptoken_decimals;
        // obj_dalao_transaction_info.number_sellpercent = Number((-bigint_dalao_spl_balance_changes) * 100n / bigint_dalao_spl_prebalance) / 100;
        obj_dalao_transaction_info.bigint_dalaoToken_PreAmount = bigint_dalao_spl_prebalance;
        obj_dalao_transaction_info.bigint_dalaoToken_NowAmount = bigint_dalao_spl_postbalance;

        return obj_dalao_transaction_info;

    }


    let arr_ammid = Object.keys(obj_transaction.obj_swap_instructions);
    console.log(arr_ammid)
    throw ("aaa")

    for (let ammid_idx = 0; ammid_idx < arr_ammid.length; ammid_idx++) {
        //此轮循环遍历 arr_ammid 寻找 wsol--token的ammid 并且dalao的token是 balance_changes>0 即疑似买入的情况
        let str_ammid = arr_ammid[ammid_idx];
        let amm_pool_info = obj_total_ammpool[str_ammid];
        if (!amm_pool_info) {
            // baseMint: info.baseMint.toString(),
            // quoteMint: info.quoteMint.toString(),
            // lpMint: info.lpMint.toString(),
            // baseDecimals: info.baseDecimal.toNumber(),
            // quoteDecimals: info.quoteDecimal.toNumber(),

            amm_pool_info = await formatAmmKeysById(str_ammid);
            obj_total_ammpool[str_ammid] = amm_pool_info;
        }

        let baseMint = amm_pool_info.baseMint;
        let quoteMint = amm_pool_info.quoteMint;
        let baseDecimals = amm_pool_info.baseDecimals;
        let quoteDecimals = amm_pool_info.quoteDecimals;

        if (baseMint != WSOL_Token_Address && quoteMint != WSOL_Token_Address) {
            //此swap 不是 SOL--Token的结构
            continue;
        }
        //遍历 instructions
        let swap_token_address, swap_token_decimals, main_token_address, main_token_decimals;
        if (baseMint == WSOL_Token_Address) {
            main_token_address = baseMint;
            main_token_decimals = baseDecimals;
            swap_token_address = quoteMint;
            swap_token_decimals = quoteDecimals;
        } else {
            main_token_address = quoteMint;
            main_token_decimals = quoteDecimals;
            swap_token_address = baseMint;
            swap_token_decimals = baseDecimals;
        }


        let dalao_spl_idx = dalao_spl_dict.mint.indexOf(swap_token_address);
        if (dalao_spl_idx == -1) {
            continue;
        }
        // 选好了 就是buy 此token 判断之前是否购买过，购买次数是否超了

        let bigint_dalao_spl_prebalance = dalao_spl_dict.prepost_balances[dalao_spl_idx][0];
        let bigint_dalao_spl_postbalance = dalao_spl_dict.prepost_balances[dalao_spl_idx][1];


        obj_dalao_transaction_info.str_swaptype = "buy";
        obj_dalao_transaction_info.str_dalao_intoken = swap_token_address;
        obj_dalao_transaction_info.str_dalao_outtoken = main_token_address;
        obj_dalao_transaction_info.str_ammid = str_ammid;
        obj_dalao_transaction_info.bigint_dalaoinamount = dalao_spl_dict.balance_changes[dalao_spl_idx];
        obj_dalao_transaction_info.bigint_dalaooutamount = router_sol_dict.balance_changes[0];
        obj_dalao_transaction_info.number_decimals_dalao_intoken = swap_token_decimals;
        obj_dalao_transaction_info.number_decimals_dalao_outtoken = main_token_decimals;
        obj_dalao_transaction_info.bigint_dalaoToken_PreAmount = bigint_dalao_spl_prebalance;
        obj_dalao_transaction_info.bigint_dalaoToken_NowAmount = bigint_dalao_spl_postbalance;
        return obj_dalao_transaction_info;
    }
    return obj_dalao_transaction_info;

}






function init_total_ammpool() {
    try {
        if (!fs.existsSync('total_ammpool.json')) {
            console.log('init_total_ammpool success');
            return
        }

        obj_total_ammpool = fs.readJSONSync('total_ammpool.json', { encoding: 'utf8', flag: 'r' });
        console.log('init_total_ammpool success');
    } catch (error) {
        console.log('init_total_ammpool error=', error.message);
    }


}




async function multimes_getTransaction(sign) {
    let retry_times = 4;
    let obj_transaction;
    while (retry_times > 0) {
        obj_transaction = await swap_connection.getTransaction(sign, { commitment: "confirmed", maxSupportedTransactionVersion: 0 });
        if (obj_transaction != null) {
            break;
        }
        else {
            retry_times--;
            await sleep(500);
            continue;
        }
    }
    if (retry_times <= 0) {
        console.log(`check_transaction failed sign=${sign} swaptoken_address=${str_swaptoken_address}`);
        throw ("not get transaction");
    }
    return obj_transaction
}


async function check_transaction(str_dalao_address, sign) {
    console.log(`check_transaction str_dalao_address=${str_dalao_address} sign=${sign}`);

    // let swaptype, str_dalao_intoken, str_dalao_outtoken, str_token_pool, bigint_dalaoinamount, bigint_dalaooutamount;
    // [swaptype, str_dalao_intoken, str_dalao_outtoken, str_token_pool, bigint_dalaoinamount, bigint_dalaooutamount]
    let obj_transaction;
    obj_transaction = fs.readJSONSync(`./myparsedtransaction/${sign}.json`);
    // console.log(obj_transaction)
    // throw ('aaaaaa')


    let obj_dalao_transaction_info = await get_dalao_transaction_info(str_dalao_address, sign, obj_transaction);

    if (obj_dalao_transaction_info.str_swaptype == "noswap") {
        console.log(`check_transaction str_swaptype=noswap sign=${sign} str_dalao_address=${str_dalao_address}`);
        return;
    }

    return

    let str_swaptype = obj_dalao_transaction_info.str_swaptype;
    let str_swapintoken = obj_dalao_transaction_info.str_dalao_outtoken;
    let str_swapouttoken = obj_dalao_transaction_info.str_dalao_intoken;
    let str_ammid = obj_dalao_transaction_info.str_ammid;
    let number_decimals_swapintoken = obj_dalao_transaction_info.number_decimals_dalao_outtoken;
    let number_decimals_swapouttoken = obj_dalao_transaction_info.number_decimals_dalao_intoken;

    let bigint_actual_swapinamount = 0n;
    let bigint_expect_swapoutamount = 0n;
    let bigint_expect_swapminoutamount = 0n;

    let bigint_dalaoToken_PreAmount = obj_dalao_transaction_info.bigint_dalaoToken_PreAmount;
    let bigint_dalaoToken_NowAmount = obj_dalao_transaction_info.bigint_dalaoToken_NowAmount;


    if (str_swaptype == "buy") {
        //buytoken swapin wsol swapout token
        bigint_actual_swapinamount = obj_dalao_transaction_info.bigint_dalaooutamount < buySolAmount0_1 ? obj_dalao_transaction_info.bigint_dalaooutamount : buySolAmount0_1;

        bigint_expect_swapoutamount = obj_dalao_transaction_info.bigint_dalaoinamount * bigint_actual_swapinamount / obj_dalao_transaction_info.bigint_dalaooutamount;
        bigint_expect_swapminoutamount = bigint_expect_swapoutamount * 7n / 10n; //浮点30%
    } else {
        //sell token 计算卖出比例

    }


    if (str_swaptype == "buy") {
        await readyBuyToken({
            dalao_address: str_dalao_address,
            sign,
            str_swapintoken,
            str_swapouttoken,
            str_ammid,
            number_decimals_swapintoken,
            number_decimals_swapouttoken,
            bigint_actual_swapinamount,
            bigint_expect_swapminoutamount,
            arr_walletTokenAccount,
            wallet,
            obj_someinfo: {
                bigint_dalaoToken_PreAmount: bigint_dalaoToken_PreAmount,
                bigint_dalaoToken_NowAmount: bigint_dalaoToken_NowAmount,
            }


        });

    } else {

        await sellToken(
            {
                dalao_address: str_dalao_address,
                sign,
                str_swapintoken,
                str_swapouttoken,
                str_ammid,
                number_decimals_swapintoken,
                number_decimals_swapouttoken,

                arr_walletTokenAccount,
                wallet,
                obj_someinfo: {
                    bigint_dalaoToken_PreAmount: bigint_dalaoToken_PreAmount,
                    bigint_dalaoToken_NowAmount: bigint_dalaoToken_NowAmount,
                }

            }
        )

    }




}




let swap_connection = new web3.Connection("https://solana-mainnet.g.alchemy.com/v2/WLI0ohbUlvbsJVmoIvB1wTSwUA8qP5qS");

let alchemy_connection_0 = new web3.Connection("https://solana-mainnet.g.alchemy.com/v2/ck1dtOx8tHkjAH2PX2FwTGN2T2gDaGtV");
let alchemy_connection_1 = new web3.Connection("https://solana-mainnet.g.alchemy.com/v2/pxF-cEkEE1JxzxgotGyww5ra5w1IvAkJ");

let alchemy_url_0 = ("https://solana-mainnet.g.alchemy.com/v2/ck1dtOx8tHkjAH2PX2FwTGN2T2gDaGtV");
let alchemy_url_1 = ("https://solana-mainnet.g.alchemy.com/v2/pxF-cEkEE1JxzxgotGyww5ra5w1IvAkJ");

let arr_listen_connection = [alchemy_connection_0, alchemy_connection_1];

let arr_listen_url = [alchemy_url_0, alchemy_url_1];


//待卖出代币map key:token
let map_pendingSellToken = new Map();
let now_listen_rpc_idx = 0;
let now_dalao_idx = 0;



check_transaction('HNioGq7YMspUh2mHmqqddsDu2uAXpfLFLAqmd6WzYDbU', 'cQrpR46rVWaWTakn6JvdMCQqMxSpcvBdWMg1TT2Z9wjvVTytA8UREnsDTPiVL8VZDNqhdabD8LnN1XoDLXHDs3e');






function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
};
function accDiv(arg1, arg2) {
    if (!arg1 || !arg2) {
        return 0;
    }
    let num = new BigNumber(arg1).div(new BigNumber(arg2));
    //BigNumber超过20个小数位就会为0 比如 0.0000000000000000000000013406750208855472013
    if (num.toFixed() == 0) {
        num = new Decimal(arg1).div(new Decimal(arg2));
    }
    return num.toFixed();
}
