
const web3 = require('@solana/web3.js');
const fs = require("fs-extra");
const BigNumber = require("bignumber.js");
const { Wallet } = require('@coral-xyz/anchor');
const Decimal = require('decimal.js');
const BN = require('bn.js');
const cron = require('node-cron');
const bs58 = require('bs58')
const raydium_sdk = require("@raydium-io/raydium-sdk");
const deepcopy = require('deepcopy');
const clear = require('clear');
const Config = require("./config")
const axios = require('axios');
const spl_token = require("@solana/spl-token");

let crontask;
let obj_dalaoAddress_2_arrdalao = Config.obj_dalaoAddress_2_arrdalao;
let mywalletaddress = Config.mywalletaddress;
let walletPrivateKey = Config.mywalletPrivateKey;
let Liquidity = raydium_sdk.Liquidity;
let LiquidityPoolKeys = raydium_sdk.LiquidityPoolKeys;
let Percent = raydium_sdk.Percent;
let Token = raydium_sdk.Token;
let TokenAmount = raydium_sdk.TokenAmount;
let CurrencyAmount = raydium_sdk.CurrencyAmount;
let ApiPoolInfoV4 = raydium_sdk.ApiPoolInfoV4;
let LIQUIDITY_STATE_LAYOUT_V4 = raydium_sdk.LIQUIDITY_STATE_LAYOUT_V4;
let MARKET_STATE_LAYOUT_V3 = raydium_sdk.MARKET_STATE_LAYOUT_V3;
let Market = raydium_sdk.Market;
let SPL_MINT_LAYOUT = raydium_sdk.SPL_MINT_LAYOUT;
let listen_axios_config = Config.listen_axios_config;

let Keypair = web3.Keypair;
let PublicKey = web3.PublicKey;


let wallet = new Wallet(Keypair.fromSecretKey(Uint8Array.from(bs58.decode(walletPrivateKey))))
// let connection = new web3.Connection("https://solana-mainnet.g.alchemy.com/v2/ck1dtOx8tHkjAH2PX2FwTGN2T2gDaGtV");
connection = new web3.Connection("https://mainnet.helius-rpc.com/?api-key=4c4f2b5f-7db5-489c-a74c-a334d8cedd76");

async function getWalletTokenAccount(wallet_pubkey) {

    const walletTokenAccount = await connection.getTokenAccountsByOwner(wallet_pubkey, {
        programId: raydium_sdk.TOKEN_PROGRAM_ID,
    });

    return walletTokenAccount.value.map((i) => ({
        pubkey: i.pubkey,
        programId: i.account.owner,
        accountInfo: raydium_sdk.SPL_ACCOUNT_LAYOUT.decode(i.account.data),
    }));

}

async function main() {
    // spl_token.closeAccount(swap_connection,)
    let arr_walletTokenAccount = await getWalletTokenAccount(wallet.publicKey);
    let arr_accountpub = [];
    for (let obj_walletTokenAccount of arr_walletTokenAccount) {
        if (obj_walletTokenAccount.accountInfo.amount == 0) {
            arr_accountpub.push(obj_walletTokenAccount.pubkey)

        }
    }
    console.log("arr_accountpub length=", arr_accountpub.length)
    if (arr_accountpub.length == 0) {
        return;
    }
    arr_accountpub = arr_accountpub.slice(0, 13)
    console.log(arr_accountpub);





    const recentBlockhash = (await connection.getLatestBlockhash()).blockhash;

    // chunks(filteredAccounts).forEach((chunk) => {
    // New empty transaction
    let transactions = []
    const txn = new web3.Transaction();
    txn.feePayer = wallet.publicKey;
    txn.recentBlockhash = recentBlockhash;
    for (let accountpub of arr_accountpub) {
        // const txn = new web3.Transaction();
        // Add a `closeAccount` instruction for every token account in the chunk
        txn.add(spl_token.createCloseAccountInstruction((accountpub), wallet.publicKey, wallet.publicKey));

    }
    transactions.push(txn);

    const signedTransactions = await wallet.signAllTransactions(transactions);

    const serializedTransactions = signedTransactions.map(t => t.serialize());
    console.log("serializedTransactions=", signedTransactions[0])

    // serializedTransactions.forEach(async t => await connection.sendRawTransaction(t));
    let res = await connection.sendRawTransaction(serializedTransactions[0])
    console.log("res=", res)

}

main()