
const web3 = require('@solana/web3.js');
const fs = require("fs-extra");
const BigNumber = require("bignumber.js");
const { Wallet } = require('@coral-xyz/anchor');
const Decimal = require('decimal.js');
const BN = require('bn.js');
const cron = require('node-cron');
const bs58 = require('bs58')
const raydium_sdk = require("@raydium-io/raydium-sdk");
const deepcopy = require('deepcopy');
const clear = require('clear');
const Config = require("./config")
const axios = require('axios');
const { getJSDocReturnTag } = require('typescript');

let jsonInfo2PoolKeys = raydium_sdk.jsonInfo2PoolKeys;


let log = console.log;
console.log = function () {
    let args = Array.from(arguments);
    let log_prefix = new Date().toISOString();
    args.unshift(log_prefix + "");
    log.apply(console, args);
}
BigInt.prototype.toJSON = function () {
    return this.toString()
}


//定时任务每秒执行一次
let crontask;
let obj_dalaoAddress_2_arrdalao = Config.obj_dalaoAddress_2_arrdalao;
let mywalletaddress = Config.mywalletaddress;
let walletPrivateKey = Config.mywalletPrivateKey;
let Liquidity = raydium_sdk.Liquidity;
let LiquidityPoolKeys = raydium_sdk.LiquidityPoolKeys;
let Percent = raydium_sdk.Percent;
let Token = raydium_sdk.Token;
let TokenAmount = raydium_sdk.TokenAmount;
let CurrencyAmount = raydium_sdk.CurrencyAmount;
let ApiPoolInfoV4 = raydium_sdk.ApiPoolInfoV4;
let LIQUIDITY_STATE_LAYOUT_V4 = raydium_sdk.LIQUIDITY_STATE_LAYOUT_V4;
let MARKET_STATE_LAYOUT_V3 = raydium_sdk.MARKET_STATE_LAYOUT_V3;
let Market = raydium_sdk.Market;
let SPL_MINT_LAYOUT = raydium_sdk.SPL_MINT_LAYOUT;
let listen_axios_config = Config.listen_axios_config;

let Keypair = web3.Keypair;
let PublicKey = web3.PublicKey;


let wallet = new Wallet(Keypair.fromSecretKey(Uint8Array.from(bs58.decode(walletPrivateKey))))

let dalaobuytokenscounts_obj = {};
let obj_sellFailedInfo = {};
// let obj_dalaoCheckStatus = {}; //dalao的状态 dalao -->[] 如何数组为空数组 说明没有对其进行tx分析 如果[true] 说明在进行分析 有一个true 就是在分析一个tx
// 遍历全部dalao的第一个address 即obj_dalaoAddress_2_arrdalao的key
for (let dalaoAddress of Object.keys(obj_dalaoAddress_2_arrdalao)) {

    dalaobuytokenscounts_obj[dalaoAddress] = {};
    // obj_dalaoCheckStatus[dalaoAddress] = [];
}

const buySolAmount0_1 = BigInt(0.1 * 10 ** 9);
const buySolAmount0_2 = BigInt(0.2 * 10 ** 9);
const buySolAmount0_00001 = BigInt(0.00001 * 10 ** 9);


let arr_total_str_dalaoAddress_forlisten = Config.arr_total_str_dalaoAddress_forlisten;
// let arr_total_web3pub_dalaoAddress_forlisten = Config.arr_total_web3pub_dalaoAddress_forlisten;
let len_arr_total_dalaoAddress = Config.len_arr_total_dalaoAddress;
let obj_dalao_existtxhash_2_set = Config.obj_dalao_existtxhash_2_set
let obj_dalao_isbusy = Config.obj_dalao_isbusy;




function saveWalletTokenAccount() {
    try {

        fs.writeJSONSync('arr_walletTokenAccount.json', arr_walletTokenAccount, { spaces: 4 });
        console.log('saveWalletTokenAccount success');

    } catch (error) {
        console.log('saveWalletTokenAccount error error=', error.message);
    }
}

async function updateWalletTokenAccount() {
    let temp_arr_walletTokenAccount;
    let retry_times = 3;
    while (retry_times > 0) {
        retry_times--;

        try {
            temp_arr_walletTokenAccount = await getWalletTokenAccount(wallet.publicKey);
            // temp_stringify = JSON.stringify(temp_arr_walletTokenAccount);
            // temp_arr_walletTokenAccount = JSON.parse(temp_stringify);
            if (temp_arr_walletTokenAccount.length == 0) {
                throw ("length error");
            }
        } catch (e) {
            console.log("updateWalletTokenAccount error", e);
            return;
        }
        arr_walletTokenAccount = temp_arr_walletTokenAccount;
        if (arr_walletTokenAccount.length != 0) {
            break;
        }
        await sleep(400);
    }


}



async function sellToken({
    dalao_address,
    sign,
    str_swapintoken,
    str_swapouttoken,
    str_ammid,
    number_decimals_swapintoken,
    number_decimals_swapouttoken,
    arr_walletTokenAccount,
    wallet,
    token_sell_amount,

} = {}) {

    let str_maintoken_address = str_swapouttoken;
    let str_swaptoken_address = str_swapintoken;
    let number_maintoken_decimals = number_decimals_swapouttoken;
    let number_swaptoken_decimals = number_decimals_swapintoken;
    console.log(`enter sellToken dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} sign=${sign} `);
    // -------- pre-action: get pool info --------
    // let ammpool = obj_total_ammpool[str_ammid];
    let ammpool = await formatAmmKeysById(str_ammid);
    let poolkeys = jsonInfo2PoolKeys(ammpool);

    let inputToken = new Token(raydium_sdk.TOKEN_PROGRAM_ID, new PublicKey(str_swaptoken_address), number_swaptoken_decimals, 'TOKEN', 'TOKEN');
    // let outputToken = new Token(raydium_sdk.TOKEN_PROGRAM_ID, new PublicKey(str_maintoken_address), number_maintoken_decimals, 'SOL', 'SOL');
    let outputToken = Token.WSOL;

    let bigint_AmountIn = token_sell_amount;
    let inputTokenAmount = new raydium_sdk.TokenAmount(inputToken, bigint_AmountIn);

    console.log(`sellToken dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} sign=${sign} token=${str_swaptoken_address} Amount=${inputTokenAmount.toFixed()}`);

    let minAmountOutRaw = 1n;
    let minAmountOut =
        outputToken instanceof Token
            ? new TokenAmount(outputToken, minAmountOutRaw)
            : new CurrencyAmount(outputToken, minAmountOutRaw)


    // -------- step 2: create instructions by SDK function --------

    const { innerTransactions } = await Liquidity.makeSwapInstructionSimple({
        connection: swap_connection,
        poolKeys: poolkeys,
        userKeys: {
            tokenAccounts: arr_walletTokenAccount,
            owner: wallet.publicKey,
        },
        amountIn: inputTokenAmount,
        amountOut: minAmountOut,
        fixedSide: 'in',
        makeTxVersion: raydium_sdk.TxVersion.V0,
        computeBudgetConfig: {
            microLamports: 2006936,
            // microLamports: 1006936,
            units: 150000,


        },
    })



    const latestBlockHash = await swap_connection.getLatestBlockhash("finalized");
    const instructions = innerTransactions[0].instructions.filter(Boolean);
    const versionedTransaction = new web3.VersionedTransaction(
        new web3.TransactionMessage({
            payerKey: wallet.publicKey,
            recentBlockhash: latestBlockHash.blockhash,
            instructions: instructions,
        }).compileToV0Message()
    )
    // //模拟卖出
    // await sleep(3000);
    // obj_dalaoInfo.bigint_myTokenAmount = obj_dalaoInfo.bigint_myTokenAmount - bigint_AmountIn;
    // console.log(`dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} sign=${sign} sellToken Success`);
    // return;
    // // 真实卖出
    versionedTransaction.sign([wallet.payer])

    let res_sign = await swap_connection.sendTransaction(versionedTransaction);
    console.log("res_sing=", res_sign);
    console.log("latestBlockHash=", latestBlockHash);
    let confirmationResult = await swap_connection.confirmTransaction(
        {
            blockhash: latestBlockHash.blockhash,
            lastValidBlockHeight: latestBlockHash.lastValidBlockHeight,
            signature: res_sign,
        }
    );
    console.log("confirmationResult=", confirmationResult);

    return;



}


function getTimeMinDiff(startDateNow, endDateNow) {
    let timeDiff = endDateNow - startDateNow;  // 时间差的毫秒数
    let min = Math.floor(timeDiff / (60 * 1000)); // 计算出分钟
    return min;
};






let arr_walletTokenAccount = [];
let obj_total_ammpool = {}; // ammid ->poolkeys {}
// let obj_total_lp_info = {}; // lp_address ->info {decimals,xxx}
// let obj_total_token_info = {}; //token_address ->info  {decimals }




async function getWalletTokenAccount(wallet_pubkey) {

    const walletTokenAccount = await swap_connection.getTokenAccountsByOwner(wallet_pubkey, {
        programId: raydium_sdk.TOKEN_PROGRAM_ID,
    });

    let newwalletTokenAccount = walletTokenAccount.value.map((i) => ({
        pubkey: i.pubkey,
        programId: i.account.owner,
        accountInfo: raydium_sdk.SPL_ACCOUNT_LAYOUT.decode(i.account.data),
    }));
    // console.log("walletTokenAccount walletTokenAccount=", newwalletTokenAccount)
    return newwalletTokenAccount;

}



let WSOL_Token_Address = "So11111111111111111111111111111111111111112";
let Token_Transfer_programId = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
let Raydium_Authority_V4 = "5Q544fKrFoe6tsEbD7S8EmxGTJYAKtTVhAW5Q5pge4j1";



function init_total_ammpool() {
    try {
        if (!fs.existsSync('total_ammpool.json')) {
            console.log('init_total_ammpool success');
            return
        }

        obj_total_ammpool = fs.readJSONSync('total_ammpool.json', { encoding: 'utf8', flag: 'r' });
        console.log('init_total_ammpool success');
    } catch (error) {
        console.log('init_total_ammpool error=', error.message);
    }


}




let swap_connection = new web3.Connection("https://mainnet.helius-rpc.com/?api-key=4c4f2b5f-7db5-489c-a74c-a334d8cedd76");

// let swap_connection = new web3.Connection("https://solana-mainnet.g.alchemy.com/v2/WLI0ohbUlvbsJVmoIvB1wTSwUA8qP5qS");



let arr_one_WalletTokenAccount = []
async function main() {
    init_total_ammpool();

    let token_sell_amount = BigInt(0);
    let str_ammid = "2DbBTD5Z4CnAGZDU3XLbs8tDLdKkLnLvMH3mCtPfBzdH";
    let str_swapintoken = "4YTyNbYrZiKYkweEPAQySXV6NbvVe34qHemDRpxRiEve";


    let number_decimals_swapintoken = 6;

    await updateWalletTokenAccount();

    saveWalletTokenAccount();


    for (let walletTokenAccount of arr_walletTokenAccount) {
        if (walletTokenAccount.accountInfo.mint.toBase58() == str_swapintoken) {
            // console.log(walletTokenAccount.accountInfo)

            arr_one_WalletTokenAccount.push(walletTokenAccount)
            token_sell_amount = walletTokenAccount.accountInfo.amount
        }
    }
    console.log("one_WalletTokenAccount", arr_one_WalletTokenAccount)

    // let arr_one_walletTokenAccount = [{
    //     "pubkey": new web3.PublicKey("AmQuAewVmGoZC5qVC7UPdNHd8b93vxzRmbgMeG7bdcS5"),
    //     "programId": new web3.PublicKey("TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA"),
    //     "accountInfo": {
    //         "mint": new web3.PublicKey(str_swapintoken),
    //         "owner": new PublicKey(mywalletaddress),
    //         "amount": new BN("11111111111", 16),
    //         "delegateOption": 0,
    //         "delegate": new web3.PublicKey("11111111111111111111111111111111"),
    //         "state": 1,
    //         "isNativeOption": 0,
    //         "isNative": new BN("00", 16),
    //         "delegatedAmount": new BN("00", 16),
    //         "closeAuthorityOption": 0,
    //         "closeAuthority": new web3.PublicKey("11111111111111111111111111111111")
    //     }
    // }]

    await sellToken(
        {
            dalao_address: undefined,
            sign: undefined,
            str_swapintoken,
            str_swapouttoken: Token.WSOL,
            str_ammid,
            number_decimals_swapintoken,
            number_decimals_swapouttoken: 9,
            // arr_walletTokenAccount: arr_walletTokenAccount,
            arr_walletTokenAccount: arr_one_WalletTokenAccount,
            wallet,
            token_sell_amount,

        }
    )

}

main()

async function multimes_getAccountInfo(web3pub_account) {
    let retry_times = 4;
    let account;
    while (retry_times > 0) {
        // obj_transaction = await swap_connection.getAccountInfo(sign, { commitment: "confirmed", maxSupportedTransactionVersion: 0 });
        account = await swap_connection.getAccountInfo(web3pub_account, 'confirmed');
        if (account != null) {
            break;
        }
        else {
            retry_times--;
            await sleep(500);
            continue;
        }
    }
    return account
}




async function formatAmmKeysById(str_ammid) {

    let account = await multimes_getAccountInfo(new PublicKey(str_ammid));
    // swap_connection.getAccountInfo(new PublicKey(str_ammid), 'confirmed');
    if (account == null) {
        console.log(`formatAmmKeysById error str_ammid=${str_ammid}`);
        throw Error('get id info error');
    }
    let info = LIQUIDITY_STATE_LAYOUT_V4.decode(account.data);

    let marketId = info.marketId;
    let marketAccount = await multimes_getAccountInfo(marketId);
    // swap_connection.getAccountInfo(marketId, 'confirmed');
    if (marketAccount == null) throw Error('get market info error');
    let marketInfo = MARKET_STATE_LAYOUT_V3.decode(marketAccount.data);

    let lpMint = info.lpMint;
    let lpMintAccount = await multimes_getAccountInfo(lpMint);
    // await swap_connection.getAccountInfo(lpMint, 'confirmed');
    if (lpMintAccount == null) throw Error('get lp mint info error');
    const lpMintInfo = SPL_MINT_LAYOUT.decode(lpMintAccount.data);

    return {
        id: str_ammid,
        baseMint: info.baseMint.toString(),
        quoteMint: info.quoteMint.toString(),
        lpMint: info.lpMint.toString(),
        baseDecimals: info.baseDecimal.toNumber(),
        quoteDecimals: info.quoteDecimal.toNumber(),
        lpDecimals: lpMintInfo.decimals,
        version: 4,
        programId: account.owner.toString(),
        authority: Liquidity.getAssociatedAuthority({ programId: account.owner }).publicKey.toString(),
        openOrders: info.openOrders.toString(),
        targetOrders: info.targetOrders.toString(),
        baseVault: info.baseVault.toString(),
        quoteVault: info.quoteVault.toString(),
        withdrawQueue: info.withdrawQueue.toString(),
        lpVault: info.lpVault.toString(),
        marketVersion: 3,
        marketProgramId: info.marketProgramId.toString(),
        marketId: info.marketId.toString(),
        marketAuthority: Market.getAssociatedAuthority({ programId: info.marketProgramId, marketId: info.marketId }).publicKey.toString(),
        marketBaseVault: marketInfo.baseVault.toString(),
        marketQuoteVault: marketInfo.quoteVault.toString(),
        marketBids: marketInfo.bids.toString(),
        marketAsks: marketInfo.asks.toString(),
        marketEventQueue: marketInfo.eventQueue.toString(),
        lookupTableAccount: PublicKey.default.toString()
    }
}



function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
};
function accDiv(arg1, arg2) {
    if (!arg1 || !arg2) {
        return 0;
    }
    let num = new BigNumber(arg1).div(new BigNumber(arg2));
    //BigNumber超过20个小数位就会为0 比如 0.0000000000000000000000013406750208855472013
    if (num.toFixed() == 0) {
        num = new Decimal(arg1).div(new Decimal(arg2));
    }
    return num.toFixed();
}



function makedirpath(mkpath) {
    if (!fs.existsSync(mkpath)) {
        fs.mkdirSync(mkpath);
    }
}
